/*********************************************************************
 *
 *         EZWGL, the EZ Widget and Graphics Library
 *
 *             Copyright (C) 1996, 1997  Maorong Zou
 *  
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **********************************************************************/
/*
 *  June 1996.  Beta Release.
 *  Sept 1996.  Release Version 1.0
 *  Dec 1996.  Release Version 1.1 Beta
 *  April 1997.  Release Version 1.2
 *  November 1997.  Release Version 1.3
 */
/*****************************************************************
 *
 *  A Simple Ugly Vector Font
 *
 */

#define EZ_TextWidth   6
#define EZ_TextHeight  9

static short EZ_VectFontTable[128][18][3] =
{
  {{0}},

  {{3,0,4},  {2,2,-2},  {2,2,2},  {3,-2,4},  {2,0,-6}, {3,4,-2}},

  {{3,0,3},  {2,0,2},  {2,1,1},  {2,1,0},  {2,1,-1},  {2,1,1},
     {3,-1,-1},  {2,0,-2},  {2,1,-1},  {3,-1,1},  {2,-1,-1},
     {2,-1,0},  {2,-1,1},  {3,6,-3}},

  {{2,1,1},  {2,0,4},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,-1,-1},
     {2,-3,0},  {3,3,0},  {2,1,-1},  {2,-1,-1},  {2,-3,0},  {3,6,-2}},

  {{3,0,4},  {2,2,2},  {2,2,-2},  {3,2,-4}},

  {{3,0,5},  {2,4,0},  {2,0,-1},  {3,2,-4}},

  {{3,1,4},  {2,2,0},  {3,0,2},  {2,-1,0},  {2,-1,-1},  {2,0,-2},
     {2,1,-1},  {2,1,0},  {3,3,-2}},

  {{3,1,2},  {2,0,4},  {3,-1,0},  {2,4,0},  {3,-1,0},  {2,0,-4},
     {3,3,-2}},

  {{3,0,2},  {2,2,2},  {3,-2,3},  {2,0,-1},  {2,4,-4}, {3,2,-2}},

  {{0}}, 

  {{3,0,-9}},

  {{3,0,2},  {2,1,-1},  {2,1,1},  {2,0,5},  {2,1,1},  {2,1,-1},  {3,2,-7}},

  {{3,0,3},  {2,4,0},  {3,0,3},  {2,-4,0},  {3,2,2},  {2,0,-4},  {3,4,-4}},

  {{0}},

  {{3,1,3},  {2,1,1},  {2,0,1},  {2,1,1},  {2,1,-1},
     {2,0,-1},  {2,-1,-1},  {2,-1,1},  {3,0,1},  {2,-1,1},
     {2,-1,-1},  {2,0,-1},  {2,1,-1},  {3,5,-3}},

  {{3,0,3},  {2,0,1},  {2,1,1},  {2,2,0},  {2,1,-1},
     {2,0,2},  {2,-2,2},  {2,-1,0},  {3,3,-4},  {2,0,-1},
     {2,-1,-1},  {2,-2,0},  {2,-1,1},  {3,6,-3}},

  {{3,4,7},  {2,-3,0},  {2,-1,-1},  {2,0,-2},  {2,1,-1},
     {2,3,0},  {3,2,-3}},
  
  {{3,0,3},  {2,3,0},  {2,1,1},  {2,0,2},  {2,-1,1},  {2,-3,0},  {3,6,-7}},

  {{3,0,4},  {2,0,2},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-2},  {3,2,-4}},

  {{3,0,7},  {2,0,-2},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,2},  {3,2,-7}},

  {{3,0,8},  {2,2,-6},  {2,2,6},  {3,-1,-2},  {2,-2,0},  {3,5,-6}},

  {{3,0,2},  {2,4,0},  {2,0,3},  {2,-3,0},  {3,-1,3},  {2,4,0},
     {2,0,-3},  {3,2,-5}},

  {{3,0,4},  {2,0,2},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-2},
     {2,-1,-1},  {2,-2,0},  {2,-1,1},  {3,1,0},  {2,2,2},  {3,-2,0},
     {2,2,-2},  {3,3,-4}},

  {{3,2,0},  {2,-2,2},  {2,4,4},  {2,-2,2},  {3,-2,-2},  {2,4,0},
    {3,-4,-4},  {2,4,0},  {3,2,-2}},

  {{2,4,0},  {3,2,0}},
  

  {{3,2,3},  {2,2,2},  {2,-2,2},  {3,-2,-2},  {2,4,0},  {3,2,-5}},

  {{3,0,8},  {2,1,1},  {2,1,0},  {2,0,-1},  {2,1,0},  {2,1,1},  {3,2,-9}},

  {{3,0,1},  {2,4,6},  {3,0,-2},  {2,-4,0},  {3,0,-2},  {2,4,0},  {3,2,-2}},

  {{3,1,2},  {2,2,0},  {3,0,2},  {2,-2,2},  {2,2,2},  {3,3,-8}},

  {{3,1,2},  {2,2,0},  {3,-2,2},  {2,2,2},  {2,-2,2},  {3,5,-8}},

  {{3,0,3},  {2,4,0},  {3,0,2},  {2,-4,0},  {3,0,2},  {2,4,0},  {3,2,-7}},

  {{3,0,6},  {2,2,-2},  {2,2,2},  {3,2,-6}},

  {{3,6,0}},

  {{3,2,1},  {2,0,1},  {3,0,2},  {2,0,4},  {3,4,-8}},

  {{3,1,7},  {2,0,2},  {3,2,0},  {2,0,-2},  {3,3,-7}},

  {{3,1,2},  {2,0,5},  {3,2,0},  {2,0,-5},  {3,1,1},  {2,-4,0},  {3,0,3},
     {2,4,0},  {3,2,-6}},

  {{3,2,1},  {2,0,8},  {3,2,-2},  {2,-1,1},  {2,-2,0},  {2,-1,-1},
     {2,0,-1},  {2,1,-1},  {2,2,0},  {2,1,-1},  {2,0,-2},  {2,-1,-1},
     {2,-2,0},  {2,-1,1},  {3,6,-3}},

  {{3,0,2},  {2,0,1},  {2,4,4},  {2,0,1},  {3,-3,0},  {2,-1,0},
     {2,0,-1},  {2,1,0},  {2,0,1},  {3,3,-5},  {2,1,0},  {2,0,-1},
     {2,-1,0},  {2,1,0},  {3,3,-1}},

  {{3,4,4},  {2,-2,-2},  {2,-1,0},  {2,-1,1},  {2,0,1},  {2,2,2},  {2,0,1},
     {2,-1,1},  {2,-1,-1},  {2,0,-1},  {2,4,-4},  {3,2,-2}},

  {{3,0,7},  {2,1,1},  {2,0,1},  {2,1,0},  {2,0,-1},  {2,-1,0},  {3,5,-7}},

  {{3,4,2},  {2,-2,2},  {2,0,2},  {2,2,2},  {3,2,-8}},

  {{3,0,2},  {2,2,2},  {2,0,2},  {2,-2,2},  {3,6,-8}},

  {{3,2,2},  {2,0,6},  {3,-2,-1},  {2,4,-4},  {3,0,2},  {2,-4,0},
     {3,0,-2},  {2,4,4},  {3,2,-7}},

  {{3,2,3},  {2,0,4},  {3,-2,-2},  {2,4,0},  {3,2,-5}},

  {{3,0,1},  {2,1,1},  {2,0,1},  {3,5,-3}},

  {{3,0,5},  {2,4,0},  {3,2,-5}},

  {{3,1,2},  {2,1,0},  {3,4,-2}},

  {{3,0,3},  {2,4,4},  {3,2,-7}},

  {{3,0,3},  {2,4,4},  {2,-1,1},  {2,-2,0},  {2,-1,-1},  {2,0,-4},
     {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,4},  {3,2,-7}},

  {{3,1,2},  {2,2,0},  {3,-1,0},  {2,0,6},  {2,-1,-1},  {3,5,-7}},

  {{3,0,7},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-1},  {2,-4,-4},
     {2,4,0},  {3,2,-2}},

  {{3,0,3},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,1},  {2,-1,1},
     {2,-1,0},   {3,1,0},  {2,1,1},  {2,0,1},  {2,-1,1},
     {2,-2,0},  {2,-1,-1},  {3,6,-7}},

  {{3,3,2},  {2,0,6},  {2,-3,-3},  {2,0,-1},  {2,4,0},  {3,2,-4}},

  {{3,0,3},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,2},  {2,-1,1},  {2,-3,0},
     {2,0,2},  {2,4,0},  {3,2,-8}},

  {{3,0,5},  {2,0,-2},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,1},
     {2,-1,1},  {2,-3,0},
     {2,0,1},  {2,2,2},  {2,1,0},  {3,3,-8}},

  {{3,0,8},  {2,4,0},  {2,-2,-4},  {2,0,-2},  {3,4,-2}},

  {{3,1,5},  {2,-1,-1},  {2,0,-1},  {2,1,-1},  {2,2,0},  {2,1,1},
     {2,0,1},  {2,-1,1},  {2,-2,0},  {2,-1,1},  {2,0,1},  {2,1,1},
     {2,2,0},  {2,1,-1},  {2,0,-1},  {2,-1,-1},  {3,3,-5}},

  {{3,1,2},  {2,1,0},  {2,2,2},  {2,0,3},  {2,-1,1},  {2,-2,0},  {2,-1,-1},
     {2,0,-1},  {2,1,-1},  {2,3,0},  {3,2,-5}},

  {{3,0,3},  {2,1,0},  {3,0,3},  {2,-1,0},  {3,6,-6}},

  {{3,0,1},  {2,1,1},  {2,0,1},  {3,0,3},  {2,-1,0},  {3,6,-6}},

  {{3,3,3},  {2,-2,2},  {2,2,2},  {3,3,-7}},

  {{3,0,4},  {2,4,0},  {3,0,2},  {2,-4,0},  {3,6,-6}},

  {{3,1,7},  {2,2,-2},  {2,-2,-2},  {3,5,-3}},

  {{3,1,2},  {2,1,0},  {3,0,2},  {2,0,1},  {2,2,2},  {2,-1,1},  {2,-2,0},
     {2,-1,-1},  {3,6,-7}},

  {{3,3,2},  {2,-2,0},  {2,-1,1},  {2,0,4},  {2,1,1},  {2,2,0},  {2,1,-1},
     {2,0,-3},  {2,-2,0},  {2,0,2},  {2,2,0},  {3,2,-6}},

  {{3,0,2},  {2,0,5},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-5},
     {3,-4,3},  {2,4,0},  {3,2,-5}},

  {{3,0,2},  {2,3,0},  {2,1,1},  {2,0,1},  {2,-1,1},  {2,-3,0},  {3,3,0},
     {2,1,1},  {2,0,1},  {2,-1,1},  {2,-3,0},  {2,0,-6},  {3,6,-2}},

  {{3,4,7},  {2,-1,1},  {2,-2,0},  {2,-1,-1},  {2,0,-4},  {2,1,-1},
     {2,2,0},  {2,1,1},  {3,2,-3}},

  {{3,0,2},  {2,3,0},  {2,1,1},  {2,0,4},  {2,-1,1},  {2,-3,0},
     {3,1,0},  {2,0,-6},  {3,5,-2}},

  {{3,4,2},  {2,-4,0},  {2,0,6},  {2,4,0},  {3,-1,-3},  {2,-3,0},  {3,6,-5}},

  {{3,0,2},  {2,0,6},  {2,4,0},  {3,-1,-3},  {2,-3,0},  {3,6,-5}},

  {{3,3,4},  {2,1,0},  {2,0,-1},  {2,-1,-1},  {2,-2,0},  {2,-1,1},
     {2,0,4},  {2,1,1},  {2,2,0},  {2,1,-1},  {3,2,-7}},

  {{3,0,2},  {2,0,6},  {3,0,-3},  {2,4,0},  {3,0,3},  {2,0,-6},  {3,2,-2}},

  {{3,1,2},  {2,2,0},  {3,-1,0},  {2,0,6},  {3,-1,0},  {2,2,0},  {3,3,-8}},

  {{3,0,3},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,5},  {3,2,-8}},

  {{3,0,2},  {2,0,6},  {3,4,0},  {2,-3,-3},  {2,3,-3},  {3,4,-2}},

  {{3,0,8},  {2,0,-6},  {2,4,0},  {3,2,-2}},

  {{3,0,2},  {2,0,6},  {2,2,-2},  {2,2,2},  {2,0,-6},  {3,2,-2}},

  {{3,0,2},  {2,0,6},  {2,4,-6},  {2,0,6},  {3,2,-8}},

  {{3,0,3},  {2,0,4},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-4},
     {2,-1,-1},  {2,-2,0},  {2,-1,1},  {3,6,-3}},

  {{3,0,2},  {2,0,6},  {2,3,0},  {2,1,-1},  {2,0,-1},  {2,-1,-1},
     {2,-3,0},  {3,6,-5}},

  {{3,0,3},  {2,0,4},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-3},  {2,-2,-2},
     {2,-1,0},  {2,-1,1},  {3,2,2},  {2,2,-2},  {3,2,-3}},

  {{3,0,2},  {2,0,6},  {2,3,0},  {2,1,-1},  {2,0,-1},  {2,-1,-1},  {2,-3,0},
     {3,1,0},  {2,3,-3},  {3,2,-2}},

  {{3,4,7},  {2,-1,1},  {2,-2,0},  {2,-1,-1},  {2,0,-1},  {2,1,-1},  {2,2,0},
     {2,1,-1},  {2,0,-1},  {2,-1,-1},  {2,-2,0},  {2,-1,1},  {3,6,-3}},

  {{3,0,8},  {2,4,0},  {3,-2,0},  {2,0,-6},  {3,4,-2}},

  {{3,0,3},  {2,0,5},  {3,4,0},  {2,0,-5},  {2,-1,-1},  {2,-2,0},
     {2,-1,1},  {3,6,-3}},

  {{3,0,8},  {2,0,-3},  {2,2,-3},  {2,2,3},  {2,0,3},  {3,2,-8}},

  {{3,0,2},  {2,0,6},  {3,4,0},  {2,0,-6},  {2,-2,2},  {2,-2,-2},  {3,6,-2}},

  {{3,0,2},  {2,4,6},  {3,-4,0},  {2,4,-6},  {3,2,-2}},

  {{3,2,2},  {2,0,3},  {2,-2,3},  {3,4,0},  {2,-2,-3},  {3,4,-5}},

  {{3,0,8},  {2,4,0},  {2,-4,-6},  {2,4,0},  {3,2,-2}},

  {{3,3,1},  {2,-2,0},  {2,0,8},  {2,2,0},  {3,3,-9}},

  {{3,0,7},  {2,4,-4},  {3,2,-3}},

  {{3,1,9},  {2,2,0},  {2,0,-8},  {2,-2,0},  {3,5,-1}},

  {{3,2,2},  {2,0,6},  {3,-2,-2},  {2,2,2},  {2,2,-2},  {3,2,-6}},

  {{3,2,3},  {2,-2,2},  {2,2,2},  {3,-2,-2},  {2,4,0},  {3,2,-5}},

  {{3,3,8},  {2,-1,0},  {2,0,1},  {2,1,0},  {2,0,-1},  {2,1,-1},  {3,2,-7}},

  {{3,1,6},  {2,2,0},  {2,1,-1},  {2,0,-3},  {2,-3,0},  {2,-1,1},  {2,1,1},
     {2,3,0},  {3,2,-4}},

  {{3,0,8},  {2,0,-6},  {2,3,0},  {2,1,1},  {2,0,2},  {2,-1,1},
     {2,-3,0},  {3,6,-6}},

  {{3,4,5},  {2,-1,1},  {2,-2,0},  {2,-1,-1},  {2,0,-2},  {2,1,-1},
     {2,3,0},  {3,2,-2}},

  {{3,4,8},  {2,0,-6},  {2,-3,0},  {2,-1,1},  {2,0,2},  {2,1,1},
     {2,3,0},  {3,2,-6}},

  {{3,3,2},  {2,-2,0},  {2,-1,1},  {2,0,2},  {2,1,1},  {2,2,0},  {2,1,-1},
     {2,-1,-1},  {2,-3,0},  {3,6,-4}},

  {{3,1,2},  {2,0,5},  {2,1,1},  {2,1,0},  {2,1,-1},  {3,-2,-2},
     {2,-2,0},  {3,6,-5}},

  {{3,1,0},  {2,2,0},  {2,1,1},  {2,0,4},  {2,-1,1},  {2,-2,0},  {2,-1,-1},
     {2,0,-2},  {2,1,-1},  {2,3,0},  {3,2,-2}},

  {{3,0,2},  {2,0,6},  {3,0,-2},  {2,3,0},  {2,1,-1},  {2,0,-3},  {3,2,-2}},

  {{3,2,2},  {2,0,3},  {3,0,1},  {2,0,1},  {3,4,-7}},

  {{3,0,1},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,4},  {3,0,1},
     {2,0,1},  {3,2,-7}},

  {{3,0,2},  {2,0,6},  {3,4,-2},  {2,-2,-2},  {2,-2,0},  {3,2,0},
     {2,2,-2},  {3,2,-2}},

  {{3,1,2},  {2,0,6},  {3,5,-8}},

  {{3,0,2},  {2,0,4},  {2,1,0},  {2,1,-1},  {2,1,1},  {2,1,-1},
     {2,0,-3},  {3,-2,0},  {2,0,3},  {3,4,-5}},

  {{3,0,2},  {2,0,4},  {2,1,-1},  {2,1,1},  {2,1,0},  {2,1,-1},
     {2,0,-3},  {3,2,-2}},

  {{3,0,3},  {2,0,2},  {2,1,1},  {2,2,0},  {2,1,-1},  {2,0,-2},
     {2,-1,-1},  {2,-2,0},  {2,-1,1},  {3,6,-3}},

  {{3,0,0},  {2,0,6},  {2,3,0},  {2,1,-1},  {2,0,-2},  
     {2,-1,-1},  {2,-3,0},  {3,6,-2}},

  {{3,4,2},  {2,-3,0},  {2,-1,1},  {2,0,2},  {2,1,1},  {2,2,0},
		{2,1,-1},  {2,0,-5},  {3,2,0}},

  {{3,0,2},  {2,0,4},  {3,0,-2},  {2,2,2},  {2,1,0},  {2,1,-1},  {3,2,-5}},

  {{3,0,2},  {2,3,0},  {2,1,1},  {2,-1,1},  {2,-2,0},  {2,-1,1},
     {2,1,1},  {2,3,0},  {3,2,-6}},

  {{3,0,6},  {2,4,0},  {3,-2,2},  {2,0,-5},  {2,1,-1},  {2,1,0},  {3,2,-2}},

  {{3,0,6},  {2,0,-3},  {2,1,-1},  {2,2,0},  {2,1,1},  {2,0,3},  {3,2,-6}},

  {{3,0,6},  {2,0,-2},  {2,2,-2},  {2,2,2},  {2,0,2},  {3,2,-6}},

  {{3,0,6},  {2,0,-3},  {2,1,-1},  {2,1,1},  {2,1,-1},  {2,1,1},
     {2,0,3},  {3,2,-6}},

  {{3,0,2},  {2,4,4},  {3,-4,0},  {2,4,-4},  {3,2,-2}},

  {{3,0,0},  {2,4,4},  {2,0,2},  {3,-4,0},  {2,0,-2},  {2,2,-2},  {3,4,-2}},

  {{3,0,6},  {2,4,0},  {2,-4,-4},  {2,4,0},  {3,2,-2}},

  {{3,4,9},  {2,-1,-1},  {2,0,-2},  {2,-1,-1},  {2,1,-1},
     {2,0,-2},  {2,1,-1},  {3,2,-1}},

  {{3,2,9},  {2,0,-9},  {3,4,0}},

  {{3,2,2},  {2,0,1},  {2,-2,2},  {2,2,2},  {2,0,1},  {3,0,-1},  {2,2,-2},
     {2,-2,-2},  {3,4,-3}},

  {{3,0,9},  {2,1,-1},  {2,0,-2},  {2,1,-1},  {2,-1,-1},
     {2,0,-2},  {2,-1,-1},  {3,6,-1}},

  {{0}},
};
/*****************************************************************/
